# Comments start with a hash symbol, blank (# ) and last until end of line.
# An empty line is treated as a comment.
# A string is any sequence of characters not containing whitespaces, tabs, newlines or other special characters.
# Threads are enumerated, starting with 0

# Transition relations
# T <thread number> <global store> <local store> <global store after the transition> <local store after the transition>

# For 2-peterson, the shared state is XYT where T=turn variable.

# thread 0 goes from A to B and sets x to 1
T 0 000 A 100 B
T 0 001 A 101 B
T 0 010 A 110 B
T 0 011 A 111 B
T 0 100 A 100 B
T 0 101 A 101 B
T 0 110 A 110 B
T 0 111 A 111 B

#thread 0 goes from B to C and sets turn to 1
T 0 000 B 001 C
T 0 010 B 011 C
T 0 100 B 101 C
T 0 110 B 111 C
T 0 001 B 001 C
T 0 011 B 011 C
T 0 101 B 101 C
T 0 111 B 111 C

# thread 0 stays in C if (y and turn), otherwise it goes to D
T 0 011 C 011 C
T 0 111 C 111 C
T 0 000 C 000 D
T 0 001 C 001 D
T 0 010 C 010 D
T 0 100 C 100 D
T 0 101 C 101 D
T 0 110 C 110 D

# thread 0 goes from D to A and sets x to 0
T 0 000 D 000 A
T 0 001 D 001 A
T 0 010 D 010 A
T 0 011 D 011 A
T 0 100 D 000 A
T 0 101 D 001 A
T 0 110 D 010 A
T 0 111 D 011 A

# thread 1 goes from A to B and sets y to 1
T 1 000 A 010 B
T 1 001 A 011 B
T 1 010 A 010 B
T 1 011 A 011 B
T 1 100 A 110 B
T 1 101 A 111 B
T 1 110 A 110 B
T 1 111 A 111 B

# thread 1 goes from B to C and sets turn to 0
T 1 000 B 000 C
T 1 001 B 000 C
T 1 010 B 010 C
T 1 011 B 010 C
T 1 100 B 100 C
T 1 101 B 100 C
T 1 110 B 110 C
T 1 111 B 110 C

# thread 1 stays in C if (x and not turn), otherwise it goes to D
T 1 100 C 100 C
T 1 110 C 110 C
T 1 000 C 000 D
T 1 001 C 001 D
T 1 010 C 010 D
T 1 011 C 011 D
T 1 101 C 101 D
T 1 111 C 111 D

# thread 1 goes from D to A and sets y to 0
T 1 000 D 000 A
T 1 001 D 001 A
T 1 010 D 000 A
T 1 011 D 001 A
T 1 100 D 100 A
T 1 101 D 101 A
T 1 110 D 100 A
T 1 111 D 101 A

# Initial states
# Init <global> <thread_1> ... <thread_n>
Init 000 A A

# Error states
# Error <global>  <thread_1> ... <thread_n>
Error 000 D D
Error 001 D D
Error 010 D D
Error 011 D D
Error 100 D D
Error 101 D D
Error 110 D D
Error 111 D D
